#!/usr/bin/perl
# Daniel E. Markle  20031223
# This script will convert Pyla 1.0.x addressbooks to the 1.1.x format.
#
# Linux/OS X directions:
# ---------------------------------------------
# -upgrade Pyla to 1.1.x
# -go to your ~/pyla/profiles directory
# -run "perl convert-adr.pl adrbook.default > adrbook.new"
# -"cp adrbook.default adrbook.backup; mv adrbook.new adrbook.default"
# -start pyla and check your addresses
#

if (scalar @ARGV != 1) {
	print "Converts Pyla 1.0.x addressbooks to 1.1.x format.\n",
		"Usage: $0 <filename>\n";
	die "Invalid number of parameters";
}
$filename = pop;

open ADRFILE, "<$filename" or die "Couldn't open $filename for reading";

while(<ADRFILE>) {
	if (/facsimiletelephonenumber/) {
		die "Already appears to be 1.1.x format";
		}
	#Remove leading and trailing {' '}
	$thisdata = substr $_, 2, -2;
	#Split records
	@thisdataset = split /', '/, $thisdata;
	print "{";
	$sep = "";
	while ( $thisrecord = pop @thisdataset ) {
		@thisrecordset = split /': '/, $thisrecord;
		print $sep . "'" . @thisrecordset[0] . "': {",
			"'facsimiletelephonenumber': '" . @thisrecordset[1],
			"', 'mail': '', 'cn': '" . @thisrecordset[0] . "'}";
		$sep = ", ";
	}
	print "}";
}
