#!/usr/bin/env python 
################################################################################
#        This is a Pyla program.
#    Copyright (C) 2003 Andrea Nicolini
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#        Andrea Nicolini's Address is:
#        
#               Via G.Zoccoli n.80 Baggiovara 
#               Modena, ITALY 
#               E-Mail <andrea@teamsw.it>
################################################################################

import sys,string,time,os,shutil,getopt,time,thread,glob
import hylaproto,hylaform,tooltip

from Tkinter import *
from tkMessageBox import *
from tkFileDialog import askopenfilename, asksaveasfilename


class StatusFrame(Frame):
        
        
        def __init__(self,parent=None):
                Frame.__init__(self,parent)
                self.parent = parent
                self.pack(fill=X)
                self.makewidgets()

        def makewidgets(self):
		sbar = Scrollbar(self)
                self.labsts = Text(self,width=80,height=3,bg='lightgray',selectborderwidth=0,selectforeground='black',selectbackground='lightgray',relief=GROOVE)
                sbar.config(command=self.labsts.yview)
                self.labsts.config(yscrollcommand=sbar.set)
                sbar.pack(side=RIGHT,fill=Y)
                self.labsts.pack(side=TOP,expand=Y,fill=X)


        def fakefocus(self,event):
                self.parent.focus()
                
        def update_status(self,event=None):
                (faxstatus,msg) = hyla.getstatus()
		self.labsts.config(state=NORMAL)
                self.labsts.delete('1.0',END)
                if faxstatus:
                        self.tmpstr = ''
                        for l in msg:
                                self.tmpstr += str(l) + '\n'
        
                        self.labsts.insert(END, self.tmpstr[:-1])
			self.labsts.config(state=DISABLED)
			if int(config['expandsts']):
				self.labsts.config(height=len(string.split(self.tmpstr,'\n'))-1)
                        return 1
                else:
                        ShowError(queue,langhash['faxerror0'],msg)
                        return 0


class ProgressBarFrame(Toplevel):

        cur_sel = 1
        imgtxt = 0
        imgbar = 0
        show_percent = 0
        txt = None

        def __init__(self,parent=None):
                Toplevel.__init__(self,parent)
                self.protocol('WM_DELETE_WINDOW',lambda:0)
                self.transient(parent)
                #self.overrideredirect(1)
                self.title('Please wait...')
                self.resizable(0,0)
                self.withdraw()
                self.makewidgets()
        
        def __add__(self,add):
                self.cur_sel = self.cur_sel + add
                self.progress()

        def progress(self):
		if self.state() == 'withdrawn': 
                	self.grab_set()
           	     	self.geometry("+%d+%d" % (root.winfo_rootx()+root.winfo_width()/2-100,root.winfo_rooty()+90))
               		self.deiconify()

                if self.cur_sel <= 50:
                        self.canvas.coords(self.imgbar,0,0,self.cur_sel*4-1,19) 
                        if self.show_percent:
                        	s = str(self.cur_sel*2) + '% isn\'t this slow?'
                                self.canvas.delete(self.txt)
                                #This may be really slow!
                                self.txt = self.canvas.create_text(100,10,anchor='c',text=s,fill='white')
                else:
                        self.canvas.coords(self.imgbar,-1,0,0,19) 
                        self.cur_sel = 1

         	        if self.canvas.itemcget(self.imgbar,'fill') == 'darkblue':
         		       	self.canvas.itemconfig(self.bgbar,fill='darkblue')
                        	self.canvas.itemconfig(self.imgbar,fill='lightgray')
               		else:
               		        self.canvas.itemconfig(self.bgbar,fill='lightgray')
                       	 	self.canvas.itemconfig(self.imgbar,fill='darkblue')

                self.update()
                                        

        def set_mesg(self,str=''):
                self.labv.set(str)

        def reset(self):
                global pbar_stop
                pbar_stop = 1
                self.show_percent = 0
                self.canvas.delete(self.txt)
                self.canvas.itemconfig(self.bgbar,fill='lightgray')
                self.canvas.itemconfig(self.imgbar,fill='darkblue')
		self.cur_sel = 0
                self.progress()
                self.set_mesg()
                self.withdraw()
                root.focus_set()
                root.grab_set()
                root.update()

        def makewidgets(self):
                self.labv = StringVar()
                self.barlab = Label(self,relief=RIDGE,textvariable=self.labv)
                self.barlab.pack(side=TOP,fill=X)
                self.canvas = Canvas(self,width=200,height=20,scrollregion=(0,0,200,20))
                self.canvas.pack(side=BOTTOM)
                self.bgbar = self.canvas.create_rectangle(0,0,199,19,fill='lightgray')
                self.imgbar = self.canvas.create_rectangle(-1,0,0,19,fill='darkblue')

        def quit(self):
                self.reset()
                self.destroy()


class QueueFrame(Frame):

        records = []
        err_msg = []

        def __init__(self,parent=None):
                Frame.__init__(self,parent)
                self.pack(expand=Y,fill=BOTH)
                self.makewidgets()
        
        def __add__(self,add):
                self.cur_sel = self.cur_sel + add
                self.ent.select_adjust(self.cur_sel)
                if self.cur_sel < len(self.message):
                        self.update()

        def makewidgets(self):
                self.lab = Label(self,width=70,anchor=W,font=('courier',10,'bold'),relief=GROOVE,bg='gray')
                
                self.list = Listbox(self,selectmode=EXTENDED,height=5,width=70,font=('courier',10),bg="White",relief=SUNKEN)
                sbar = Scrollbar(self)
                sbar.config(command=self.list.yview)

                self.list.config(yscrollcommand=sbar.set)
                self.list.bind('<ButtonRelease-1>',get_sbinfo)
                self.list.bind('<Double-1>',get_recvfax)
                self.lab.pack(side=TOP,fill=X)
                sbar.pack(side=RIGHT,fill=Y)
                self.list.pack(side=TOP,expand=Y,fill=BOTH)

		self.popup = Menu(root, tearoff=0)

		self.list.bind("<Button-3>",self.do_popup)

	def do_popup(self,event):
		self.list.select_clear(0,END)
		self.list.select_set(self.list.nearest(event.y))
	    	# display the popup menu
	       	try:
		        self.popup.tk_popup(event.x_root, event.y_root)
		finally:
           	# make sure to release the grab (Tk 8.0a1 only)
			self.popup.grab_release()

        def get_sel(self,event=None):
                selected = self.list.curselection()
                
                if selected:
                        if type(selected[0]) == type(int(0)):
                                return selected
                        else:
                                tmpl = []
                                for i in selected:
                                        tmpl.append(int(i))
                                return tmpl
        
        def update_status_lck(self,event=None):
                
                if not mutex.locked():
        		mutex.acquire()
                        dsp_barmsg()
                        self.update_status()
        		mutex.release()

        def update_status(self,event=None):

                pos = 0
                self.err_msg = []
                self.records = []

                stat_msg = {
                        '?' : langhash['statmsg?'],
                        'T' : langhash['statmsgT'],
                        'P' : langhash['statmsgP'],
                        'S' : langhash['statmsgS'],
                        'B' : langhash['statmsgB'],
                        'W' : langhash['statmsgW'],
                        'R' : langhash['statmsgR'],
                        'D' : langhash['statmsgD'],
                        'F' : langhash['statmsgF']
                }

                tscm_msg = {
			''  : langhash['tscmmsg'],
                        'f' : langhash['tscmmsgf'],
                        'm' : langhash['tscmmsgm'],
                        'a' : langhash['tscmmsga'],
                        'S' : langhash['tscmmsgS'],
                        'W' : langhash['tscmmsgW'],
                        'R' : langhash['tscmmsgR'],
                        'D' : langhash['tscmmsgD'],
                        'F' : langhash['tscmmsgF'],
                        'P' : langhash['tscmmsgP'],
                        'p' : langhash['tscmmsgP'],
                }

                queue = queuevar.get()

                if not queue:
                        queue = 'sendq'

		self.popup.delete(0,END)
		menu.jobs.entryconfig(0,state=DISABLED)
		menu.jobs.entryconfig(1,state=DISABLED)
		menu.jobs.entryconfig(2,state=DISABLED)
		menu.jobs.entryconfig(3,state=DISABLED)

                if queue == 'sendq':
                        button.butSendq.config(relief=SUNKEN)
                        button.butRecvq.config(relief=RAISED)
                        button.butDoneq.config(relief=RAISED)
			if tscm:
                        	self.lab.config(text=langhash['tscmsendqlab'])
			else:
                        	self.lab.config(text=langhash['hylasendqlab'])
                        (status,joblist) = hyla.getqueue(queue,view=viewvar.get())
                elif queue == 'recvq':
                        button.butSendq.config(relief=RAISED)
                        button.butRecvq.config(relief=SUNKEN)
                        button.butDoneq.config(relief=RAISED)
			if tscm:
                        	self.lab.config(text=langhash['tscmrecvqlab'])
			else:
                        	self.lab.config(text=langhash['hylarecvqlab'])

			if config.has_key('hidercv') and int(config['hidercv']) and not config['adminpass']:
				status = 1
				joblist = []
			else:
                        	(status,joblist) = hyla.getqueue(queue,'%-15t|%-15s|%-2p|%-15f')
				
                elif queue == 'doneq':
                        button.butSendq.config(relief=RAISED)
                        button.butRecvq.config(relief=RAISED)
                        button.butDoneq.config(relief=SUNKEN)
			if tscm:
                        	self.lab.config(text=langhash['tscmdoneqlab'])
			else:
                        	self.lab.config(text=langhash['hyladoneqlab'])
                        (status,joblist) = hyla.getqueue(queue,view=viewvar.get())

                self.list.delete(0,END)

                if status:
                        if joblist:
                                if queue == 'sendq':
                                        button.butsus.config(state=NORMAL)
                                        button.butsub.config(state=NORMAL)
                                        button.butmod.config(state=NORMAL,command=modify_job)
                                        button.butdel.config(state=NORMAL,command=(lambda:job_command('jkill')))
					menu.jobs.entryconfig(0,state=NORMAL)
					menu.jobs.entryconfig(1,state=NORMAL)
					menu.jobs.entryconfig(2,state=NORMAL,command=modify_job)
					menu.jobs.entryconfig(3,state=NORMAL,command=(lambda:job_command('jkill')))
					self.popup.add_command(label=langhash['popupsuspend'],command=(lambda:job_command('jsusp')))
					self.popup.add_command(label=langhash['popupsubmit'],command=(lambda:job_command('jsubm')))
					self.popup.add_command(label=langhash['popupmodify'],command=modify_job)
					self.popup.add_command(label=langhash['popupdelete'],command=(lambda:job_command('jkill')))
                                elif queue == 'recvq':
                                        button.butsus.config(state=DISABLED)
                                        button.butsub.config(state=DISABLED)
                                        button.butmod.config(state=DISABLED)
                                        button.butdel.config(state=DISABLED)
					if not tscm: joblist = self.RecvqSort(joblist)
					self.popup.add_command(label=langhash['popupview'],command=get_recvfax)
					self.popup.add_command(label=langhash['popupsave'],command=(lambda:get_recvfax(action='save')))
                                elif queue == 'doneq':
                                        button.butsus.config(state=DISABLED)
                                        button.butsub.config(state=DISABLED)
					if tscm:
						menu.jobs.entryconfig(2,state=NORMAL,command=resend_job)
                                        	button.butmod.config(state=NORMAL,command=resend_job)
						self.popup.add_command(label=langhash['popupresend'],command=resend_job)
					else:
                                        	button.butmod.config(state=DISABLED)
                                        button.butdel.config(state=NORMAL,command=(lambda:job_command('jdele')))
					menu.jobs.entryconfig(3,state=NORMAL,command=(lambda:job_command('jdele')))
					self.popup.add_command(label=langhash['popupdelete'],command=(lambda:job_command('jdele')))

				self.popup.add_separator()
				self.popup.add_command(label=langhash['popupcancel'])
                
                                for l in joblist:
                                        if queue == 'recvq':
						if tscm:
                                              		self.records.append(l)
                                                	self.err_msg.append(l[3])
							l[1] = l[1][:22]
                                                	insstr = "%-14s %-22s %-10s %-6s" %\
							(l[0],l[1],l[2],l[3])
						else:
                                             		rec = string.split(l,'|')
                                            	   	self.err_msg.append(rec[-1])
                                               		self.records.append(rec)
                                               		rec[1] = rec[1][:15]
                                               		insstr = "%-15s %-15s %-7s %-15s" %\
							(rec[0],rec[1],rec[2],rec[3])

                                         	self.list.insert(pos,insstr)
                                        else:
						if tscm:
                                              		self.records.append(l)
                                                	self.err_msg.append(l[-1])
                                                	jobstatus = tscm_msg[l[4]] 
							
							if queue == 'sendq' and l[8]:
								jobstatus = l[8] + "(%s:%s)" % (l[6],l[7])
							
							type = tscm_msg[l[5]]
                                                	l[1] = l[1][:10]
                                                	l[2] = l[2][:20]
                                                	insstr = "%-6s %-10s %-20s %-11s  %-4s    %-15s" %\
							(l[0],l[1],l[2],l[3],type,jobstatus)
						else:
                                           		rec = string.split(l,'|')
                                              		self.records.append(rec)
                                                	self.err_msg.append(rec[-1])
                                                	del rec[-1]
                                                	jobstatus = stat_msg[rec[4]]
                                                	rec[1] = rec[1][:10]
                                                	rec[2] = rec[2][:15]
                                                	insstr = "%-6s %-10s %-15s  %-5s   %-5s     %-7s  %-15s" % (rec[0],rec[1],rec[2],rec[3],rec[5],rec[6],jobstatus)

                                                self.list.insert(pos,insstr)
                                        pos = pos + 1
                        else:
                                button.butsus.config(state=DISABLED)
                                button.butsub.config(state=DISABLED)
                                button.butdel.config(state=DISABLED)
                                button.butmod.config(state=DISABLED)
				self.popup.add_command(label=langhash['popupcancel'])
                        return 1
                else:
                        ShowError(self,langhash['faxerror0'],joblist)
                        return 0

        def RecvqSort(self,jlist):
                
                tmphash = {}
                tmplist = []
                retlist = []

                for l in jlist:
                        tmphash[string.split(l,'|')[-1]] = l
                
                tmplist = tmphash.keys()
                tmplist.sort()
                tmplist.reverse()

                for k in tmplist:
                        retlist.append(tmphash[k])
                        
                return retlist

                
class ButtonFrame(Frame):

        def __init__(self,parent=None):
                Frame.__init__(self,parent)
                self.pack(fill=X)
                self.imgSendfax = PhotoImage(file=os.path.join(gifdir,"open.gif"))
                self.imgSendcover = PhotoImage(file=os.path.join(gifdir,"cover.gif"))
                self.imgPrefs = PhotoImage(file=os.path.join(gifdir,"pref.gif"))
                self.imgAdrbook = PhotoImage(file=os.path.join(gifdir,"adrbook.gif"))
                self.imgUpdate = PhotoImage(file=os.path.join(gifdir,"refresh.gif"))
                self.imgAlter = PhotoImage(file=os.path.join(gifdir,"alter.gif"))
                self.imgSuspend = PhotoImage(file=os.path.join(gifdir,"suspend.gif"))
                self.imgSubmit = PhotoImage(file=os.path.join(gifdir,"submit.gif"))
                self.imgDelete = PhotoImage(file=os.path.join(gifdir,"trash.gif"))
                self.imgExit = PhotoImage(file=os.path.join(gifdir,"exit.gif"))
                self.imgSendq = PhotoImage(file=os.path.join(gifdir,"sendq.gif"))
                self.imgRecvq = PhotoImage(file=os.path.join(gifdir,"recvq.gif"))
                self.imgDoneq = PhotoImage(file=os.path.join(gifdir,"doneq.gif"))
                self.config(relief=GROOVE,bd=2)
                self.makewidgets()

        def makewidgets(self):
                self.framesx = Frame(self)
                self.framesx.pack(side=LEFT)
                self.filler = Frame(self,width=20)
                self.filler.pack(side=LEFT)
                self.framein = Frame(self)
                self.framein.pack(side=LEFT)
                self.filler2 = Frame(self,width=30)
                self.filler2.pack(side=LEFT)
                self.framein2 = Frame(self)
                self.framein2.pack(side=LEFT)
                self.framedx = Frame(self)
                self.framedx.pack(side=RIGHT)
                                                         
                butSendCover = Button(self.framesx,text="Send cover",image=self.imgSendcover,command=(lambda:send_fax_form(1)))
                butSendCover.pack(side=LEFT)
                tooltip.ToolTip(butSendCover,langhash['tipsendcover'])

                butSendFax = Button(self.framesx,text="Send fax",image=self.imgSendfax,command=send_file)
                butSendFax.pack(side=LEFT)
                tooltip.ToolTip(butSendFax,langhash['tipsendfax'])

                butAddrBook = Button(self.framesx,text="Address book",image=self.imgAdrbook,command=address_book)
                butAddrBook.pack(side=LEFT)
                tooltip.ToolTip(butAddrBook,langhash['tipaddressbook'])
                
                butPrefs = Button(self.framesx,text="Preferences",image=self.imgPrefs,command=configure_form)
                butPrefs.pack(side=LEFT)
                tooltip.ToolTip(butPrefs,langhash['tippreferences'])
                
                self.butSendq = Button(self.framein,text="sendq",image=self.imgSendq,relief=SUNKEN,command=self.sendq_update)
                self.butSendq.pack(side=LEFT)   
                tooltip.ToolTip(self.butSendq,langhash['tipsendq'])

                self.butRecvq = Button(self.framein,text="recvq",image=self.imgRecvq,command=self.recvq_update)
                self.butRecvq.pack(side=LEFT)   
                tooltip.ToolTip(self.butRecvq,langhash['tiprecvq'])

                self.butDoneq = Button(self.framein,text="doneq",image=self.imgDoneq,command=self.doneq_update)
                self.butDoneq.pack(side=LEFT)
                tooltip.ToolTip(self.butDoneq,langhash['tipdoneq'])

                butRefresh = Button(self.framein2,text="Update",image=self.imgUpdate,command=update_all)
                butRefresh.pack(side=LEFT)
                tooltip.ToolTip(butRefresh,langhash['tiprefresh'])

                self.butmod = Button(self.framein2,text="Modify",image=self.imgAlter,command=modify_job)
                self.butmod.pack(side=LEFT)
                tooltip.ToolTip(self.butmod,langhash['tipmodifyjob'])
                
                self.butsus = Button(self.framein2,text="Suspend",image=self.imgSuspend,state=DISABLED,command=(lambda:job_command('jsusp')))   
                self.butsus.pack(side=LEFT)
                tooltip.ToolTip(self.butsus,langhash['tipsuspendjob'])

                self.butsub = Button(self.framein2,text="Submit",image=self.imgSubmit,state=DISABLED,command=(lambda:job_command('jsubm')))     
                self.butsub.pack(side=LEFT)
                tooltip.ToolTip(self.butsub,langhash['tipsubmitjob'])
                
                self.butdel = Button(self.framein2,text="Delete",image=self.imgDelete,state=DISABLED,command=(lambda:job_command('jkill')))
                self.butdel.pack(side=LEFT)
                tooltip.ToolTip(self.butdel,langhash['tipdeletejob'])
                
                butExit = Button(self.framedx,text="Exit",image=self.imgExit,command=nice_quit)
                butExit.pack(side=RIGHT)
                tooltip.ToolTip(butExit,langhash['tipexitpyla'])

        def sendq_update(self):
                if queuevar.get() != 'sendq':
                        queuevar.set('sendq')
                        queue.update_status_lck()
                
        def recvq_update(self):
                if queuevar.get() != 'recvq':
                        queuevar.set('recvq')
                        queue.update_status_lck()

        def doneq_update(self):
                if queuevar.get() != 'doneq':
                        queuevar.set('doneq')
                        queue.update_status_lck()

class StatusBarFrame(Frame):
        
        def __init__(self,parent=None):
                Frame.__init__(self,parent)
                self.parent = parent
                self.pack(fill=X)
                self.makewidgets()

        def makewidgets(self):
                self.v = StringVar()
                self.errlab = Label(self,width=30,justify=LEFT,anchor=W,relief=GROOVE,textvariable=self.v,bg='lightgray')
                self.errlab.pack(side=TOP,fill=X)
                
class MenuFrame:

        def __init__(self,parent=None):
                self.top = Menu(parent)
                parent.config(menu=self.top)
                self.makemenu(parent)

        def makemenu(self,win): 
                
                self.file = Menu(self.top,tearoff=0)
                self.file.add_command(label=langhash['menuconfigure'],command=configure_form)
                self.file.add_command(label=langhash['menuaddrbook'],command=address_book)
                self.file.add_separator()
                self.file.add_command(label=langhash['menusendfile'],command=send_file)
                self.file.add_command(label=langhash['menuresend'],command=send_last)
                self.file.add_command(label=langhash['menusendcover'],command=(lambda:send_fax_form(1)))
                self.file.add_separator()
                self.file.add_command(label=langhash['menuexit'],command=nice_quit)

                self.view = Menu(self.top,tearoff=0)
                self.view.add_radiobutton(label=langhash['menupriv'],variable=viewvar,value='priv',command=queue.update_status_lck)
                self.view.add_radiobutton(label=langhash['menupub'],variable=viewvar,value='pub',command=queue.update_status_lck)
                self.view.add_separator()
                self.view.add_command(label=langhash['menuselect'],command=select_all)

                self.hosts = Menu(self.top,tearoff=0)
		for h in string.split(config['faxhost'],','):
                	self.hosts.add_radiobutton(label=h,variable=curhost,value=h,command=change_host)
                curhost.set(string.split(config['faxhost'],',')[0])

                self.jobs = Menu(self.top,tearoff=0)
                self.jobs.add_command(label=langhash['menususpendjob'],command=(lambda:job_command('jsusp')))
                self.jobs.add_command(label=langhash['menusubmitjob'],command=(lambda:job_command('jsubm')))
                self.jobs.add_command(label=langhash['menumodifyjob'],command=modify_job)
                self.jobs.add_command(label=langhash['menudeletejob'],command=(lambda:job_command('jkill')))
                
                self.queues = Menu(self.top,tearoff=0)
                self.queues.add_radiobutton(label=langhash['menusendq'],variable=queuevar,value='sendq',command=queue.update_status_lck)
                self.queues.add_radiobutton(label=langhash['menurecvq'],variable=queuevar,value='recvq',command=queue.update_status_lck)
                self.queues.add_radiobutton(label=langhash['menudoneq'],variable=queuevar,value='doneq',command=queue.update_status_lck)
                self.help = Menu(self.top,tearoff=0)
                self.help.add_command(label=langhash['menuabout'],command=about_pyla)

                self.top.add_cascade(label=langhash['menufile'],menu=self.file,underline=0)
                self.top.add_cascade(label=langhash['menuview'],menu=self.view,underline=0)
                self.top.add_cascade(label=langhash['menuhosts'],menu=self.hosts,underline=0)
                self.top.add_cascade(label=langhash['menujob'],menu=self.jobs,underline=0)
                self.top.add_cascade(label=langhash['menuqueue'],menu=self.queues,underline=0)
                self.top.add_cascade(label=langhash['menuhelp'],menu=self.help,underline=0)
                queuevar.set('sendq')
        

#Functions
def update_all(event=None,msg=[]):
        if not mutex.locked():
        	thread.start_new_thread(th_update_all,(msg,))

def select_all(event=None):
	queue.list.select_set(0,END)

def th_update_all(msg=[]):
        mutex.acquire()
        dsp_barmsg(langhash['barupdate'])
        if status.update_status() and queue.update_status():
                dsp_barmsg(msg)
        
        mutex.release()

def get_sbinfo(self,event=None):
        idx = queue.get_sel()
        if idx != None and queue.records:
                q = queuevar.get()
                if q == 'recvq':
                        dsp_barmsg(langhash['barviewfax']+queue.err_msg[idx[-1]])
                else:
                        errlist = []
        
                        for i in idx:
                                errlist.append('Job '+queue.records[i][0]+' -> '+queue.err_msg[i])      
                        dsp_barmsg(errlist)
        else:
                dsp_barmsg()

def get_recvfax(event=None,action='display'):
	
        idx = queue.get_sel()
        q = queuevar.get()
	if not idx: idx = []

        if q == 'recvq':
        	if config['viewer'] and os.access(config['viewer'],os.X_OK):
               	         for i in idx:
               	                err = hyla.get_recvfile(string.strip(queue.records[i][-1]))
               	                if err:
               	                	ShowError(queue,langhash['faxerror0'],err)
	
        	              	else:
					if action == 'save':
                				filename = asksaveasfilename(title=langhash['asksavefax'],filetypes=[('Tiff','*.tif')])
						if filename:
							filename = os.path.normpath(filename)
        						try:
								shutil.copyfile(hyla.recvfile,filename)
							except:
                						ShowError(queue,langhash['saveerror0'],langhash['saveerror1'])

					elif action == 'display':
                				thread.start_new_thread(launch_app,(config['viewer'],hyla.recvfile))
     		else:
       	        	ShowError(queue,'Viewer error','No fax viewer configured.')

def launch_app(app,file):
        os.spawnl(os.P_WAIT,app,os.path.basename(app),file)

def resend_job():
        sel = queue.get_sel()
	if sel == None:
		dsp_barmsg(langhash['barjoberror0'])
	else:		
		id = queue.records[sel[0]][0]
		adr = queue.records[sel[0]][2]
		trn = queue.records[sel[0]][5]
        	jobres = hylaform.ResJobFrame(root,adr,trn)

        	if jobres.is_OK:
			hyla.resendjob(id,jobres.address,jobres.transport,jobres.duplicate)

def modify_job():
        sel = queue.get_sel()
        if sel == None:
                dsp_barmsg(langhash['barjoberror0'])
        elif queue.records[sel[0]][4] != 'T' and queue.records[sel[0]][4] != 'S':
                dsp_barmsg(langhash['barjoberror1'])
        else:
                jobmod = hylaform.ModJobFrame(root,is_tscm=tscm)
                if jobmod.is_OK:
                        hyla.parmhash = {}

			ltd = lth = ltm = 0
                        if jobmod.sendtime:
				if tscm:
                               	 	hyla.setparm('sendtime',time.strftime("%Y%m%d%H%M",time.localtime(time.time() + (jobmod.sendtime * 60))))
				else:
                                	hyla.setparm('sendtime',time.strftime("%Y%m%d%H%M",time.gmtime(time.time() + (jobmod.sendtime * 60))))
					jobmod.expiretime += jobmod.sendtime
                        else:
				if tscm:
                                	hyla.setparm('sendtime','')
				else:
                                	hyla.setparm('sendtime','now')

                       	ltd = jobmod.expiretime / 1440
                        lth = (jobmod.expiretime % 1440) / 60
                       	ltm = jobmod.expiretime % 60
                        hyla.setparm('lasttime','%02i%02i%02i' % (ltd,lth,ltm))

                        schedpri = jobmod.priority * 64 - 1
                        hyla.setparm('schedpri','%i' % schedpri)
                        hyla.setparm('maxdials','%i' % jobmod.maxdials)

                        err = hyla.alterjob(queue.records[sel[0]][0])
                        update_all(msg=err)

def job_command(cmd):
        global pbar_stop
        sel = queue.get_sel()

        if sel == None:
                dsp_barmsg(langhash['barjoberror0'])
        elif not mutex.locked():
                thread.start_new_thread(th_job_command,(cmd,sel))
                pbar_stop = 0
                pbar_wave()

def th_job_command(cmd,sel):
        global pbar_stop
        jids = []
	
        if queue.records:
                for j in sel:
                        jids.append(queue.records[j][0])

                dsp_barmsg(langhash['barprocjob'] % cmd)
        
                mutex.acquire()
                pbar_stop = 0
                #thread.start_new_thread(pbar_wave,())
                err = hyla.jobcmd(cmd,jids)
                pbar_stop = 1
                mutex.release()
        
                dsp_barmsg(err)
                queue.update_status()
        else:
                dsp_barmsg(langhash['barjoberror0'])

def dsp_barmsg(msg=[],bgcolor=None):

        mesg = []

        if type(msg) == type([]):
                mesg = msg
        else:
                mesg.append(msg)
                
        if not bgcolor:
                bgcolor = 'lightgray'
        statusbar.errlab.config(bg=bgcolor)

        tmpstr = ''
        line_num = 0
	
        for l in mesg:
                if line_num == 10:
                        tmpstr += '...' + '\n'
                        break

                tmpstr += str(l) + '\n'
                line_num = line_num + 1
        
        statusbar.v.set(tmpstr[:-1])
        
def send_last():
	if os.access(spooldir,os.F_OK):
		shutil.rmtree(spooldir)
	if os.access(spooldir+'.old',os.F_OK):
		shutil.move(spooldir+'.old',spooldir)
	send_fax_form()

def send_file():
        if not mutex.locked():
                filenames = askopenfilename(title=langhash['asksendfile'],multiple='yes',filetypes=[('Tiff','*.tif'),('Postscript','*.ps'),('Pdf','*.pdf'),('All Files','*.*')])

		if filenames:
                	for f in filenames:
				if os.access(f,os.F_OK):
					save_tmp(f)
				else:
                       		 	ShowError(queue,langhash['faxerror0'],langhash['spoolerror'])
					return
               	 	send_fax_form()
         
        
def send_fax_form(OnlyCover=0):

        if OnlyCover:
                if not config['faxcover']:
                        ShowError(queue,langhash['faxerror0'],langhash['covererror0'])
                        return
        else:
                if not os.access(spooldir,os.F_OK) or not os.listdir(spooldir):
                        ShowError(queue,langhash['faxerror0'],langhash['spoolerror'])
                        return
        
        
        if not mutex.locked():
                if os.access(backupfile,os.F_OK):
			backup = file(backupfile,'r')
			backuphash = eval(backup.read())
			backup.close()
		else:
			backuphash = {}

		flst = []
		if os.access(spooldir,os.F_OK):
			flst = map((lambda x: os.path.join(spooldir,x)),os.listdir(spooldir)) 	
		fqn = len(flst) 	

                if OnlyCover:
                        sendfax = hylaform.SendFaxFrame(None,backuphash,conly=1,is_tscm=tscm)
                else:
                        sendfax = hylaform.SendFaxFrame(None,backuphash,is_tscm=tscm,fnum=fqn)
                root.update()

                if sendfax.is_OK == 1 or  sendfax.is_OK == 2:
                        if sendfax.is_OK == 2:
                                hyla.coverpath = sendfax.cover_path
                        else:
                                hyla.coverpath = ''
                
                        if OnlyCover:
                                hyla.filepaths = ''
                        else:
                                hyla.filepaths = flst

                	if int(config['coverasdoc']):
                        	hyla.cover_as_document = 1
			
                        hyla.vhash['to'] = sendfax.cover_to
                        hyla.vhash['from'] = sendfax.cover_from
                        hyla.vhash['to-company'] = sendfax.cover_to_company
                        hyla.vhash['todays-date'] = time.strftime(config['coverdate'],time.localtime(time.time()))
                        hyla.vhash['regarding'] = sendfax.cover_regarding
                        hyla.vhash['comments'] = sendfax.cover_comments

			if config.has_key('pagewidth'):
				hyla.setparm('pagewidth',config['pagewidth'])
			else:
				hyla.setparm('pagewidth','209')

			if config.has_key('pagelength'):
			        hyla.setparm('pagelength',config['pagelength'])
			else:
			        hyla.setparm('pagelength','296')
							
                        if sendfax.jobinfo:
                                hyla.setparm('jobinfo',"Facsimile '"+sendfax.jobinfo+"'")

			ltd = lth = ltm = 0
                        if sendfax.sendtime:
				if tscm:
                               	 	hyla.setparm('sendtime',time.strftime("%Y%m%d%H%M",time.localtime(time.time() + (sendfax.sendtime * 60))))
				else:
                                	hyla.setparm('sendtime',time.strftime("%Y%m%d%H%M",time.gmtime(time.time() + (sendfax.sendtime * 60))))
					sendfax.expiretime += sendfax.sendtime
                        else:
				if tscm:
                                	hyla.setparm('sendtime','')
				else:
                                	hyla.setparm('sendtime','now')

                        ltd = sendfax.expiretime / 1440
                       	lth = (sendfax.expiretime % 1440) / 60
                       	ltm = sendfax.expiretime % 60
                        hyla.setparm('lasttime','%02i%02i%02i' % (ltd,lth,ltm))

                        if sendfax.modem and sendfax.modem != 'Any':
                       		hyla.setparm('modem',sendfax.modem)

                        if sendfax.archive == langhash['archiveopt1']: 
                                hyla.setparm('doneop','"archive"')
                        elif sendfax.archive == langhash['archiveopt0']:
                                hyla.setparm('doneop','"remove"')

                        schedpri = sendfax.priority * 64 - 1
			
                        hyla.setparm('schedpri','%i' % schedpri)
                        hyla.setparm('maxdials','%i' % sendfax.maxdials)

                        if string.strip(config['emailaddress']):
                                hyla.setparm('notify',config['notify'])
                                hyla.setparm('notifyaddr','%s' % config['emailaddress'])
                                
			if tscm and not sendfax.comvar.get():
				hyla.multicover = 1

                        hyla.sendhash = sendfax.sendhash

			backup = file(backupfile,'w')
			backup.write(str(sendfax.sendhash))
			backup.close()

                        msgl = []
                        try:
				if config['addressbook']:
   	    	 			ab = eval(config['addressbook'])
   				else:
       					ab = {}
                                for j in hyla.sndfax(ab):
					if j == 'Error':
                                        	msgl.append(langhash['jobsuberr'])
					else:
                                        	msgl.append(langhash['jobsubok'])

                        except Exception,msg:
                                hylaform.ErrorBox(queue,langhash['faxerror0'],msg)
                        else:   
				if not send_mode:
                                	update_all(msg=msgl)
			
			if os.access(spooldir+'.old',os.F_OK):
				shutil.rmtree(spooldir+'.old')
			if os.access(spooldir,os.F_OK):
				shutil.move(spooldir,spooldir+'.old')
					
                elif not sendfax.is_OK:
			if  os.access(spooldir,os.F_OK):
				shutil.rmtree(spooldir)
			
                if send_mode:
                	root.quit()
                
def configure_form():
        global config
	global tscm
        if not mutex.locked():
                configfrm = hylaform.ConfigurationFrame(config,tscm)
                if configfrm.is_OK:
                        cfgfile = open(rcfile,'w+')
                        for k in config.keys():
                                cfgfile.write('%s=%s\n' % (k,config[k]))
                        cfgfile.close()
      
                config = hylaform.config = loadcfg()
		menu.hosts.delete(0,END)
		for h in string.split(config['faxhost'],','):
                	menu.hosts.add_radiobutton(label=h,variable=curhost,value=h,command=change_host)
                curhost.set(string.split(config['faxhost'],',')[0])

def address_book():
        if not mutex.locked():
                hylaform.AddressBookFrame(abfile,{},is_tscm=tscm)
                
def loadcfg():
	global tscm 
	global hyla
	global print_debug

        cfg = {}        
        cfg['faxhost'] = ''
        cfg['username'] = ''
        cfg['userdesc'] = ''
        cfg['password'] = ''
        cfg['adminpass'] = ''
        cfg['emailaddress'] = ''
        cfg['modemlist'] = ''
        cfg['coverdate'] = '%d/%m/%y'
        cfg['maxdials'] = 12
        cfg['viewer'] = ''
        cfg['faxcover'] = ''
        cfg['default_cover'] = ''
        cfg['addressbook'] = ''
        cfg['default_adr'] = ''
        cfg['protocol'] = 'hylafax'
        cfg['notify'] = 'done'
        cfg['debug'] = 0
        cfg['coverasdoc'] = 0
        cfg['expandsts'] = 0
        cfg['refonclick'] = 1
        cfg['archive'] = 0

        if os.access(rcfile,os.F_OK):
                cfgfile = open(rcfile,'r')
                for l in cfgfile.readlines():
                        if string.strip(l)[0] != '#':
                                vlist = string.split(l,'=')
                                key = vlist[0]
                                val = string.join(vlist[1:],'=')
                                cfg[key] = val[:-1]
                cfgfile.close()

        if use_common_profile and os.access(comrcfile,os.F_OK):
                cfgfile = open(comrcfile,'r')
                for l in cfgfile.readlines():
                        if string.strip(l)[0] != '#':
                                vlist = string.split(l,'=')
                                key = vlist[0]
                                val = string.join(vlist[1:],'=')
                                cfg[key] = val[:-1]
                cfgfile.close()

	if cfg['protocol'] == 'hylafax':
		tscm = 0
		#hyla = hylaproto.Hylafax(string.split(cfg['faxhost'],',')[0],debug=0)
		#hyla.ftp.set_debuglevel(int(cfg['debug']))
		hyla = hylaproto.Hylafax(string.split(cfg['faxhost'],',')[0],debug=int(cfg['debug']))
	else:
		tscm = 1
		hyla = hylaproto.Hylafax(string.split(cfg['faxhost'],',')[0],8888,'tscm')

	hyla.recvfile = os.path.join(tempdir,'recvfax.' + profile)
	hyla.username = cfg['username']
	hyla.password = cfg['password']
	hyla.adminpass = cfg['adminpass']
        hyla.cover_as_document = int(cfg['coverasdoc'])

	if tscm:
		if cfg['faxcover']:
   	    	 	chash = eval(cfg['faxcover'])
  	 	else:
       			chash = {}
		nhash = hyla.getcovers()
		for k in nhash.keys():
			chash[k] = nhash[k]
		cfg['faxcover'] = str(chash)

		if cfg['addressbook']:
   	    	 	chash = eval(cfg['addressbook'])
   		else:
       			chash = {}
		nhash = hyla.getldaps()
		for k in nhash.keys():
			chash[k] = nhash[k]
		cfg['addressbook'] = str(chash)

        return cfg

                 
def save_tmp(path=None):

	if not os.access(spooldir,os.F_OK):
		os.mkdir(spooldir)

	ld = os.listdir(spooldir)
	
	if ld:
		fname = "%05i" % (int(ld[-1]) + 1)
	else:
		fname = "00000"

        if path:
                srcfile = os.path.normpath(path)
		shutil.copy(srcfile,os.path.join(spooldir,fname))
                return 1
        else:
		tmpfile = file(os.path.join(spooldir,fname),'wb')
                tmpfile.write(sys.stdin.read())
               	tmpfile.close()
                return 1

                        
def ShowError(*args):
        queue.after_idle(hylaform.ErrorBox,*args)

        
def about_pyla():
        hylaform.AboutFrame()

def pbar_wave():
        if not pbar_stop: 
                pbar.set_mesg(langhash['barproc'])
        while not pbar_stop:
                time.sleep(0.5)
                pbar + 5
        pbar.reset()

def nice_quit():
        global pbar_stop
        pbar_stop = 1
        root.after_idle(root.quit)

def startup_actions():     
	th_update_all()

def change_host():
	host = string.strip(curhost.get())
	if config['protocol'] == 'hylafax':
		tscm = 0
		hyla.setfaxhost(host,4559)
	else:
		tscm = 1
		hyla.setfaxhost(host,8888)
	update_all()

################################################################################
	
pylaver = 'v1.1.7'
pbar = None
pbar_stop = 1
print_debug = 0
send_mode = 0
use_common_profile = 1
defview = sendfile = profile = ''
autosecs = 0
tscm = 0
hyla = None
langhash = {}

#Chdir avoids some import trouble (ldap)
os.chdir(os.path.realpath(os.path.dirname(sys.argv[0]))) 

mutex = thread.allocate_lock()
basedir = os.path.dirname(os.path.abspath(sys.argv[0]))
	
try:
        optlist, args = getopt.getopt(sys.argv[1:],'ica:f:q:')
except getopt.GetoptError, errMsg:
        print errMsg 
        print "Usage: pyla.py [-ilc] [-f file] [-q sendq|recvq|doneq] [profile]"
        print "-i = stdin mode, for fax printers."
        print "-l = local mode."
        print "-c = ignore common profile."
        print "-f = specify file to send."
        print "-q = specify default queue."
        print "profile = specify the configuration profile to use."
        print "file = send file mode, specify the file to send."
        sys.exit()   
		
for o,a in optlist:
        if o == '-i':
                send_mode = 1
        if o == '-c':
		use_common_profile = 0
        if o == '-f':
                send_mode = 1
        	sendfile = a
       		if not os.access(sendfile,os.F_OK) or not os.path.isfile(sendfile):
			print 'Error:',sendfile,'is not readable.'
       			sys.exit()   
        if o == '-q':
		if a == 'recvq' or a == 'doneq':
			defview = a
			
		
if args:
        profile = args[0]
else: 
        profile = "default"
	
if os.environ.has_key('windir'):
        #tempdir = os.path.expandvars('$windir\\temp\\')
        tempdir = os.path.expandvars('$temp\\')
else:
        tempdir = '/tmp/'

		
f = open(os.path.join(basedir,'language.db'))
langhash = hylaform.langhash = eval(f.read())
f.close()


gifdir = hylaform.gifdir = os.path.join(basedir,'gifs')
rcfile = os.path.join(basedir,'profiles','pylarc.'+profile)
comrcfile = os.path.join(basedir,'profiles','pylarc.COMMON')
abfile = hylaform.abfile = os.path.join(basedir,'profiles','adrbook.'+profile)
config = hylaform.config = loadcfg()
	
spooldir = os.path.join(tempdir,'faxtmpdir.' + profile)
backupfile = os.path.join(tempdir,'sndbku.' + profile)

root = Tk()
root.title('Fax Client ' + pylaver + ' - [%s]' % profile)
queuevar = StringVar()
viewvar = StringVar()
curhost = StringVar()
	
if not config['faxhost']:
        root.after(1000,configure_form)
else:
        if send_mode:
                thread.start_new_thread(save_tmp,(sendfile,))
                root.withdraw()
                root.after(500,send_fax_form)
        else:
                root.after(200,startup_actions)
	
if hyla.adminpass:
        viewvar.set('pub')
else:
        viewvar.set('priv')
	        
button = ButtonFrame(root)
status = StatusFrame(root)
queue = QueueFrame(root)
statusbar = StatusBarFrame(root)
pbar = hylaproto.pbar = ProgressBarFrame(root)
menu = MenuFrame(root)

if defview == 'recvq':
        button.recvq_update()
elif defview == 'doneq':
        button.doneq_update()

root.bind('<KeyPress-F5>',update_all)
root.protocol('WM_DELETE_WINDOW',nice_quit)
root.mainloop()
	
